<template>
  <form @submit.prevent="$emit('submit')">
    <div class="field">
      <label class="label">Name</label>
      <div class="control">
        <input
          :value="name"
          @input="$emit('update:name', $event.target.value)"
          class="input"
          type="text"
          placeholder="Text input"
          autofocus
        >
      </div>
    </div>
    <div class="buttons">
      <button
        type="submit"
        class="button is-primary"
        :class="{ 'is-loading': loading }"
        :disabled="!validate"
      >{{ button }}</button>
      <button
        type="button"
        class="button is-primary"
        :disabled="loading"
        @click="$emit('cancel')"
      >Cancel</button>
    </div>
  </form>
</template>

<script lang="ts">
  import { Component, Vue, Prop } from 'vue-property-decorator';

  @Component<LocationForm>({})
  export default class LocationForm extends Vue {
    @Prop({
      type: String,
      required: true,
    }) name!: string;

    @Prop({
      type: Boolean,
      default: false,
    }) loading!: boolean;

    @Prop({
      type: String,
      default: 'Create',
    }) button!: string;

    get validate() {
      return (this.name && this.name.trim().length > 0);
    }
  }
</script>
